HDU-5119 Happy Matt Friends(背包)

来源:互联网 发布:如何获取微博数据 编辑:程序博客网 时间:2024/06/09 01:04

Happy Matt Friends

Time Limit: 6000/6000 MS (Java/Others)    Memory Limit: 510000/510000 K (Java/Others)
Total Submission(s): 3341    Accepted Submission(s): 1301


Problem Description
Matt has N friends. They are playing a game together.

Each of Matt’s friends has a magic number. In the game, Matt selects some (could be zero) of his friends. If the xor (exclusive-or) sum of the selected friends’magic numbers is no less than M , Matt wins.

Matt wants to know the number of ways to win.
 

Input
The first line contains only one integer T , which indicates the number of test cases.

For each test case, the first line contains two integers N, M (1 ≤ N ≤ 40, 0 ≤ M ≤ 106).

In the second line, there are N integers ki (0 ≤ ki ≤ 106), indicating the i-th friend’s magic number.
 

Output
For each test case, output a single line “Case #x: y”, where x is the case number (starting from 1) and y indicates the number of ways where Matt can win.
 

Sample Input
23 21 2 33 31 2 3
 

Sample Output
Case #1: 4Case #2: 2
Hint
In the first sample, Matt can win by selecting:friend with number 1 and friend with number 2. The xor sum is 3.friend with number 1 and friend with number 3. The xor sum is 2.friend with number 2. The xor sum is 2.friend with number 3. The xor sum is 3. Hence, the answer is 4.
 

Source
2014ACM/ICPC亚洲区北京站-重现赛(感谢北师和上交)
题意:有n个数,随意取数使得异或和不小于m,问有多少种取法

题解:由于题意说明每个数都小于1e6,最多只有40个数,我们可以用背包来做,背包容量就是1e6,物品数量是n,dp[i][j]表示当取到第i个数的时候,能使背包容量为j的方法数,

dp[i][j]=dp[i-1][j]+dp[i-1][j^a[i]],dp[i-1][j]表示不取a[i],dp[i-1][j^a[i]]表示取a[i]

#include<cstdio>#include<vector>#include<algorithm>#include<functional>#include<string.h>using namespace std;typedef long long LL;LL dp[41][1<<20];int a[41];int main(){    int T,n,m;  //  freopen("in.txt","r",stdin);    scanf("%d",&T);    for(int cas=1;cas<=T;cas++){        scanf("%d%d",&n,&m);        for(int i=1;i<=n;i++) scanf("%d",&a[i]);        int mx=1<<20;        memset(dp,0,sizeof(dp));        dp[0][0]=1;        for(int i=1;i<=n;i++){            for(int j=0;j<mx;j++){                dp[i][j]=dp[i-1][j^a[i]]+dp[i-1][j];            }        }        LL ans=0;        for(int i=m;i<mx;i++) ans+=dp[n][i];        printf("Case #%d: %I64d\n",cas,ans);    }    return 0;}


0 0
原创粉丝点击